Index: /branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.Designer.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.Designer.cs	(revision 4725)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.Designer.cs	(revision 4726)
@@ -222,335 +544,149 @@
             this.tabPage6.UseVisualStyleBackColor = true;
             // 
-            // dgvUsers
-            // 
-            this.dgvUsers.AutoGenerateColumns = false;
-            this.dgvUsers.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
-            this.dgvUsers.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
-            this.membershipDataGridViewTextBoxColumn,
-            this.applicationIdDataGridViewTextBoxColumn,
-            this.userIdDataGridViewTextBoxColumn,
-            this.userNameDataGridViewTextBoxColumn,
-            this.loweredUserNameDataGridViewTextBoxColumn,
-            this.mobileAliasDataGridViewTextBoxColumn,
-            this.isAnonymousDataGridViewCheckBoxColumn,
-            this.lastActivityDateDataGridViewTextBoxColumn});
-            this.dgvUsers.DataSource = this.bsUsers;
-            this.dgvUsers.Dock = System.Windows.Forms.DockStyle.Fill;
-            this.dgvUsers.Location = new System.Drawing.Point(3, 3);
-            this.dgvUsers.Name = "dgvUsers";
-            this.dgvUsers.Size = new System.Drawing.Size(1086, 288);
-            this.dgvUsers.TabIndex = 1;
-            // 
-            // dgvRoles
-            // 
-            this.dgvRoles.AllowUserToAddRows = false;
-            this.dgvRoles.AllowUserToDeleteRows = false;
-            this.dgvRoles.AutoGenerateColumns = false;
-            this.dgvRoles.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
-            this.dgvRoles.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
-            this.roleIdDataGridViewTextBoxColumn,
-            this.roleNameDataGridViewTextBoxColumn,
-            this.loweredRoleNameDataGridViewTextBoxColumn,
-            this.descriptionDataGridViewTextBoxColumn});
-            this.dgvRoles.DataSource = this.bsRoles;
-            this.dgvRoles.Dock = System.Windows.Forms.DockStyle.Fill;
-            this.dgvRoles.Location = new System.Drawing.Point(3, 3);
-            this.dgvRoles.MultiSelect = false;
-            this.dgvRoles.Name = "dgvRoles";
-            this.dgvRoles.Size = new System.Drawing.Size(1086, 288);
-            this.dgvRoles.TabIndex = 2;
-            // 
-            // panel1
-            // 
-            this.panel1.Controls.Add(this.label1);
-            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
-            this.panel1.Location = new System.Drawing.Point(0, 0);
-            this.panel1.Name = "panel1";
-            this.panel1.Size = new System.Drawing.Size(1100, 47);
-            this.panel1.TabIndex = 0;
-            // 
-            // label1
-            // 
-            this.label1.Dock = System.Windows.Forms.DockStyle.Fill;
-            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-            this.label1.Location = new System.Drawing.Point(0, 0);
-            this.label1.Name = "label1";
-            this.label1.Size = new System.Drawing.Size(1100, 47);
-            this.label1.TabIndex = 0;
-            this.label1.Text = "Heuristic Lab User Management";
-            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
-            // 
-            // membershipDataGridViewTextBoxColumn
-            // 
-            this.membershipDataGridViewTextBoxColumn.DataPropertyName = "Membership";
-            this.membershipDataGridViewTextBoxColumn.HeaderText = "Membership";
-            this.membershipDataGridViewTextBoxColumn.Name = "membershipDataGridViewTextBoxColumn";
-            // 
-            // applicationIdDataGridViewTextBoxColumn
-            // 
-            this.applicationIdDataGridViewTextBoxColumn.DataPropertyName = "ApplicationId";
-            this.applicationIdDataGridViewTextBoxColumn.HeaderText = "ApplicationId";
-            this.applicationIdDataGridViewTextBoxColumn.Name = "applicationIdDataGridViewTextBoxColumn";
-            // 
-            // userIdDataGridViewTextBoxColumn
-            // 
-            this.userIdDataGridViewTextBoxColumn.DataPropertyName = "UserId";
-            this.userIdDataGridViewTextBoxColumn.HeaderText = "UserId";
-            this.userIdDataGridViewTextBoxColumn.Name = "userIdDataGridViewTextBoxColumn";
+            // label3
+            // 
+            this.label3.AutoSize = true;
+            this.label3.Location = new System.Drawing.Point(501, 18);
+            this.label3.Name = "label3";
+            this.label3.Size = new System.Drawing.Size(79, 13);
+            this.label3.TabIndex = 6;
+            this.label3.Text = "available Users";
+            // 
+            // label2
+            // 
+            this.label2.AutoSize = true;
+            this.label2.Location = new System.Drawing.Point(6, 18);
+            this.label2.Name = "label2";
+            this.label2.Size = new System.Drawing.Size(79, 13);
+            this.label2.TabIndex = 5;
+            this.label2.Text = "assigned Users";
+            // 
+            // dgvRoleAssignedUsers
+            // 
+            this.dgvRoleAssignedUsers.AllowUserToAddRows = false;
+            this.dgvRoleAssignedUsers.AllowUserToDeleteRows = false;
+            this.dgvRoleAssignedUsers.AutoGenerateColumns = false;
+            this.dgvRoleAssignedUsers.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+            this.dgvRoleAssignedUsers.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
+            this.userNameDataGridViewTextBoxColumn2});
+            this.dgvRoleAssignedUsers.DataSource = this.bsRoleUsers;
+            this.dgvRoleAssignedUsers.Location = new System.Drawing.Point(6, 34);
+            this.dgvRoleAssignedUsers.Name = "dgvRoleAssignedUsers";
+            this.dgvRoleAssignedUsers.Size = new System.Drawing.Size(346, 110);
+            this.dgvRoleAssignedUsers.TabIndex = 4;
+            // 
+            // userNameDataGridViewTextBoxColumn2
+            // 
+            this.userNameDataGridViewTextBoxColumn2.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.Fill;
+            this.userNameDataGridViewTextBoxColumn2.DataPropertyName = "UserName";
+            this.userNameDataGridViewTextBoxColumn2.HeaderText = "UserName";
+            this.userNameDataGridViewTextBoxColumn2.Name = "userNameDataGridViewTextBoxColumn2";
+            // 
+            // bsRoleUsers
+            // 
+            this.bsRoleUsers.DataSource = typeof(HeuristicLab.Services.Authentication.DataTransfer.User);
+            // 
+            // btnAddUserToRole
+            // 
+            this.btnAddUserToRole.Location = new System.Drawing.Point(469, 34);
+            this.btnAddUserToRole.Name = "btnAddUserToRole";
+            this.btnAddUserToRole.Size = new System.Drawing.Size(29, 23);
+            this.btnAddUserToRole.TabIndex = 3;
+            this.btnAddUserToRole.Text = "+";
+            this.btnAddUserToRole.UseVisualStyleBackColor = true;
+            this.btnAddUserToRole.Click += new System.EventHandler(this.btnAddUserToRole_Click);
+            // 
+            // btnRemoveUserFromRole
+            // 
+            this.btnRemoveUserFromRole.Location = new System.Drawing.Point(358, 34);
+            this.btnRemoveUserFromRole.Name = "btnRemoveUserFromRole";
+            this.btnRemoveUserFromRole.Size = new System.Drawing.Size(29, 23);
+            this.btnRemoveUserFromRole.TabIndex = 2;
+            this.btnRemoveUserFromRole.Text = "-";
+            this.btnRemoveUserFromRole.UseVisualStyleBackColor = true;
+            this.btnRemoveUserFromRole.Click += new System.EventHandler(this.btnRemoveUserFromRole_Click);
+            // 
+            // dgvRoleAvailableUsers
+            // 
+            this.dgvRoleAvailableUsers.AllowUserToAddRows = false;
+            this.dgvRoleAvailableUsers.AllowUserToDeleteRows = false;
+            this.dgvRoleAvailableUsers.AutoGenerateColumns = false;
+            this.dgvRoleAvailableUsers.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+            this.dgvRoleAvailableUsers.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
+            this.userNameDataGridViewTextBoxColumn1});
+            this.dgvRoleAvailableUsers.DataSource = this.bsUsers;
+            this.dgvRoleAvailableUsers.Location = new System.Drawing.Point(504, 34);
+            this.dgvRoleAvailableUsers.Name = "dgvRoleAvailableUsers";
+            this.dgvRoleAvailableUsers.SelectionMode = System.Windows.Forms.DataGridViewSelectionMode.FullRowSelect;
+            this.dgvRoleAvailableUsers.Size = new System.Drawing.Size(348, 110);
+            this.dgvRoleAvailableUsers.TabIndex = 1;
+            // 
+            // userNameDataGridViewTextBoxColumn1
+            // 
+            this.userNameDataGridViewTextBoxColumn1.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.Fill;
+            this.userNameDataGridViewTextBoxColumn1.DataPropertyName = "UserName";
+            this.userNameDataGridViewTextBoxColumn1.HeaderText = "UserName";
+            this.userNameDataGridViewTextBoxColumn1.Name = "userNameDataGridViewTextBoxColumn1";
+            // 
+            // bsUserRoles
+            // 
+            this.bsUserRoles.DataSource = typeof(HeuristicLab.Services.Authentication.DataTransfer.Role);
+            // 
+            // Membership
+            // 
+            this.Membership.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
+            this.Membership.DataPropertyName = "Membership.Email";
+            this.Membership.HeaderText = "EMail";
+            this.Membership.Name = "Membership";
+            this.Membership.Width = 58;
+            // 
+            // isAnonymousDataGridViewCheckBoxColumn
+            // 
+            this.isAnonymousDataGridViewCheckBoxColumn.DataPropertyName = "IsAnonymous";
+            this.isAnonymousDataGridViewCheckBoxColumn.HeaderText = "IsAnonymous";
+            this.isAnonymousDataGridViewCheckBoxColumn.Name = "isAnonymousDataGridViewCheckBoxColumn";
             // 
             // userNameDataGridViewTextBoxColumn
             // 
+            this.userNameDataGridViewTextBoxColumn.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.Fill;
             this.userNameDataGridViewTextBoxColumn.DataPropertyName = "UserName";
             this.userNameDataGridViewTextBoxColumn.HeaderText = "UserName";
             this.userNameDataGridViewTextBoxColumn.Name = "userNameDataGridViewTextBoxColumn";
             // 
-            // loweredUserNameDataGridViewTextBoxColumn
-            // 
-            this.loweredUserNameDataGridViewTextBoxColumn.DataPropertyName = "LoweredUserName";
-            this.loweredUserNameDataGridViewTextBoxColumn.HeaderText = "LoweredUserName";
-            this.loweredUserNameDataGridViewTextBoxColumn.Name = "loweredUserNameDataGridViewTextBoxColumn";
-            // 
-            // mobileAliasDataGridViewTextBoxColumn
-            // 
-            this.mobileAliasDataGridViewTextBoxColumn.DataPropertyName = "MobileAlias";
-            this.mobileAliasDataGridViewTextBoxColumn.HeaderText = "MobileAlias";
-            this.mobileAliasDataGridViewTextBoxColumn.Name = "mobileAliasDataGridViewTextBoxColumn";
-            // 
-            // isAnonymousDataGridViewCheckBoxColumn
-            // 
-            this.isAnonymousDataGridViewCheckBoxColumn.DataPropertyName = "IsAnonymous";
-            this.isAnonymousDataGridViewCheckBoxColumn.HeaderText = "IsAnonymous";
-            this.isAnonymousDataGridViewCheckBoxColumn.Name = "isAnonymousDataGridViewCheckBoxColumn";
-            // 
-            // lastActivityDateDataGridViewTextBoxColumn
-            // 
-            this.lastActivityDateDataGridViewTextBoxColumn.DataPropertyName = "LastActivityDate";
-            this.lastActivityDateDataGridViewTextBoxColumn.HeaderText = "LastActivityDate";
-            this.lastActivityDateDataGridViewTextBoxColumn.Name = "lastActivityDateDataGridViewTextBoxColumn";
-            // 
-            // tabPage3
-            // 
-            this.tabPage3.AutoScroll = true;
-            this.tabPage3.Controls.Add(emailLabel);
-            this.tabPage3.Controls.Add(this.emailTextBox);
-            this.tabPage3.Controls.Add(passwordSaltLabel);
-            this.tabPage3.Controls.Add(this.passwordSaltTextBox);
-            this.tabPage3.Controls.Add(passwordQuestionLabel);
-            this.tabPage3.Controls.Add(this.passwordQuestionTextBox);
-            this.tabPage3.Controls.Add(passwordAnswerLabel);
-            this.tabPage3.Controls.Add(this.passwordAnswerTextBox);
-            this.tabPage3.Controls.Add(passwordLabel);
-            this.tabPage3.Controls.Add(this.passwordTextBox);
-            this.tabPage3.Controls.Add(isAnonymousLabel);
-            this.tabPage3.Controls.Add(this.isAnonymousCheckBox);
-            this.tabPage3.Location = new System.Drawing.Point(4, 22);
-            this.tabPage3.Name = "tabPage3";
-            this.tabPage3.Padding = new System.Windows.Forms.Padding(3);
-            this.tabPage3.Size = new System.Drawing.Size(1078, 159);
-            this.tabPage3.TabIndex = 0;
-            this.tabPage3.Text = "Detail";
-            this.tabPage3.UseVisualStyleBackColor = true;
-            // 
-            // isAnonymousLabel
-            // 
-            isAnonymousLabel.AutoSize = true;
-            isAnonymousLabel.Location = new System.Drawing.Point(15, 22);
-            isAnonymousLabel.Name = "isAnonymousLabel";
-            isAnonymousLabel.Size = new System.Drawing.Size(76, 13);
-            isAnonymousLabel.TabIndex = 0;
-            isAnonymousLabel.Text = "Is Anonymous:";
-            // 
-            // isAnonymousCheckBox
-            // 
-            this.isAnonymousCheckBox.DataBindings.Add(new System.Windows.Forms.Binding("CheckState", this.bsUsers, "IsAnonymous", true));
-            this.isAnonymousCheckBox.Location = new System.Drawing.Point(98, 17);
-            this.isAnonymousCheckBox.Name = "isAnonymousCheckBox";
-            this.isAnonymousCheckBox.Size = new System.Drawing.Size(104, 24);
-            this.isAnonymousCheckBox.TabIndex = 1;
-            this.isAnonymousCheckBox.Text = "checkBox1";
-            this.isAnonymousCheckBox.UseVisualStyleBackColor = true;
-            // 
-            // passwordLabel
-            // 
-            passwordLabel.AutoSize = true;
-            passwordLabel.Location = new System.Drawing.Point(15, 73);
-            passwordLabel.Name = "passwordLabel";
-            passwordLabel.Size = new System.Drawing.Size(56, 13);
-            passwordLabel.TabIndex = 2;
-            passwordLabel.Text = "Password:";
-            // 
-            // passwordTextBox
-            // 
-            this.passwordTextBox.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.bsUsers, "Membership.Password", true));
-            this.passwordTextBox.Location = new System.Drawing.Point(98, 70);
-            this.passwordTextBox.Name = "passwordTextBox";
-            this.passwordTextBox.Size = new System.Drawing.Size(203, 20);
-            this.passwordTextBox.TabIndex = 3;
-            // 
-            // passwordAnswerLabel
-            // 
-            passwordAnswerLabel.AutoSize = true;
-            passwordAnswerLabel.Location = new System.Drawing.Point(318, 46);
-            passwordAnswerLabel.Name = "passwordAnswerLabel";
-            passwordAnswerLabel.Size = new System.Drawing.Size(94, 13);
-            passwordAnswerLabel.TabIndex = 4;
-            passwordAnswerLabel.Text = "Password Answer:";
-            // 
-            // passwordAnswerTextBox
-            // 
-            this.passwordAnswerTextBox.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.bsUsers, "Membership.PasswordAnswer", true));
-            this.passwordAnswerTextBox.Location = new System.Drawing.Point(425, 43);
-            this.passwordAnswerTextBox.Name = "passwordAnswerTextBox";
-            this.passwordAnswerTextBox.Size = new System.Drawing.Size(188, 20);
-            this.passwordAnswerTextBox.TabIndex = 5;
-            // 
-            // passwordQuestionLabel
-            // 
-            passwordQuestionLabel.AutoSize = true;
-            passwordQuestionLabel.Location = new System.Drawing.Point(318, 73);
-            passwordQuestionLabel.Name = "passwordQuestionLabel";
-            passwordQuestionLabel.Size = new System.Drawing.Size(101, 13);
-            passwordQuestionLabel.TabIndex = 6;
-            passwordQuestionLabel.Text = "Password Question:";
-            // 
-            // passwordQuestionTextBox
-            // 
-            this.passwordQuestionTextBox.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.bsUsers, "Membership.PasswordQuestion", true));
-            this.passwordQuestionTextBox.Location = new System.Drawing.Point(425, 70);
-            this.passwordQuestionTextBox.Name = "passwordQuestionTextBox";
-            this.passwordQuestionTextBox.Size = new System.Drawing.Size(188, 20);
-            this.passwordQuestionTextBox.TabIndex = 7;
-            // 
-            // passwordSaltLabel
-            // 
-            passwordSaltLabel.AutoSize = true;
-            passwordSaltLabel.Location = new System.Drawing.Point(15, 99);
-            passwordSaltLabel.Name = "passwordSaltLabel";
-            passwordSaltLabel.Size = new System.Drawing.Size(77, 13);
-            passwordSaltLabel.TabIndex = 8;
-            passwordSaltLabel.Text = "Password Salt:";
-            // 
-            // passwordSaltTextBox
-            // 
-            this.passwordSaltTextBox.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.bsUsers, "Membership.PasswordSalt", true));
-            this.passwordSaltTextBox.Location = new System.Drawing.Point(99, 96);
-            this.passwordSaltTextBox.Name = "passwordSaltTextBox";
-            this.passwordSaltTextBox.Size = new System.Drawing.Size(202, 20);
-            this.passwordSaltTextBox.TabIndex = 9;
-            // 
-            // emailLabel
-            // 
-            emailLabel.AutoSize = true;
-            emailLabel.Location = new System.Drawing.Point(15, 46);
-            emailLabel.Name = "emailLabel";
-            emailLabel.Size = new System.Drawing.Size(35, 13);
-            emailLabel.TabIndex = 10;
-            emailLabel.Text = "Email:";
-            // 
-            // emailTextBox
-            // 
-            this.emailTextBox.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.bsUsers, "Membership.Email", true));
-            this.emailTextBox.Location = new System.Drawing.Point(98, 43);
-            this.emailTextBox.Name = "emailTextBox";
-            this.emailTextBox.Size = new System.Drawing.Size(203, 20);
-            this.emailTextBox.TabIndex = 11;
-            // 
-            // dataGridView1
-            // 
-            this.dataGridView1.AllowUserToAddRows = false;
-            this.dataGridView1.AllowUserToDeleteRows = false;
-            this.dataGridView1.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
-            this.dataGridView1.Location = new System.Drawing.Point(6, 22);
-            this.dataGridView1.Name = "dataGridView1";
-            this.dataGridView1.ReadOnly = true;
-            this.dataGridView1.Size = new System.Drawing.Size(437, 91);
-            this.dataGridView1.TabIndex = 0;
-            // 
-            // roleNameLabel
-            // 
-            roleNameLabel.AutoSize = true;
-            roleNameLabel.Location = new System.Drawing.Point(12, 22);
-            roleNameLabel.Name = "roleNameLabel";
-            roleNameLabel.Size = new System.Drawing.Size(63, 13);
-            roleNameLabel.TabIndex = 0;
-            roleNameLabel.Text = "Role Name:";
-            // 
-            // roleNameTextBox
-            // 
-            this.roleNameTextBox.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.bsRoles, "RoleName", true));
-            this.roleNameTextBox.Location = new System.Drawing.Point(81, 19);
-            this.roleNameTextBox.Name = "roleNameTextBox";
-            this.roleNameTextBox.Size = new System.Drawing.Size(191, 20);
-            this.roleNameTextBox.TabIndex = 1;
-            // 
-            // dataGridView2
-            // 
-            this.dataGridView2.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
-            this.dataGridView2.Location = new System.Drawing.Point(34, 28);
-            this.dataGridView2.Name = "dataGridView2";
-            this.dataGridView2.Size = new System.Drawing.Size(520, 108);
-            this.dataGridView2.TabIndex = 0;
-            // 
-            // roleIdDataGridViewTextBoxColumn
-            // 
-            this.roleIdDataGridViewTextBoxColumn.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
-            this.roleIdDataGridViewTextBoxColumn.DataPropertyName = "RoleId";
-            this.roleIdDataGridViewTextBoxColumn.HeaderText = "Id";
-            this.roleIdDataGridViewTextBoxColumn.Name = "roleIdDataGridViewTextBoxColumn";
-            this.roleIdDataGridViewTextBoxColumn.Width = 41;
-            // 
-            // roleNameDataGridViewTextBoxColumn
-            // 
-            this.roleNameDataGridViewTextBoxColumn.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.Fill;
-            this.roleNameDataGridViewTextBoxColumn.DataPropertyName = "RoleName";
-            this.roleNameDataGridViewTextBoxColumn.HeaderText = "Name";
-            this.roleNameDataGridViewTextBoxColumn.Name = "roleNameDataGridViewTextBoxColumn";
-            // 
-            // loweredRoleNameDataGridViewTextBoxColumn
-            // 
-            this.loweredRoleNameDataGridViewTextBoxColumn.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
-            this.loweredRoleNameDataGridViewTextBoxColumn.DataPropertyName = "LoweredRoleName";
-            this.loweredRoleNameDataGridViewTextBoxColumn.HeaderText = "Lowered Name";
-            this.loweredRoleNameDataGridViewTextBoxColumn.Name = "loweredRoleNameDataGridViewTextBoxColumn";
-            this.loweredRoleNameDataGridViewTextBoxColumn.Width = 96;
-            // 
-            // descriptionDataGridViewTextBoxColumn
-            // 
-            this.descriptionDataGridViewTextBoxColumn.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
-            this.descriptionDataGridViewTextBoxColumn.DataPropertyName = "Description";
-            this.descriptionDataGridViewTextBoxColumn.HeaderText = "Description";
-            this.descriptionDataGridViewTextBoxColumn.Name = "descriptionDataGridViewTextBoxColumn";
-            this.descriptionDataGridViewTextBoxColumn.Width = 85;
-            // 
             // UserManagement
             // 
             this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
             this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-            this.ClientSize = new System.Drawing.Size(1100, 556);
+            this.ClientSize = new System.Drawing.Size(1100, 610);
             this.Controls.Add(this.scMain);
             this.Name = "UserManagement";
             this.Text = "UserManagement";
-            ((System.ComponentModel.ISupportInitialize)(this.bsUsers)).EndInit();
-            ((System.ComponentModel.ISupportInitialize)(this.bsRoles)).EndInit();
             this.scMain.Panel1.ResumeLayout(false);
             this.scMain.Panel2.ResumeLayout(false);
             ((System.ComponentModel.ISupportInitialize)(this.scMain)).EndInit();
             this.scMain.ResumeLayout(false);
+            this.panel1.ResumeLayout(false);
+            ((System.ComponentModel.ISupportInitialize)(this.bsApplications)).EndInit();
             this.tabControl1.ResumeLayout(false);
             this.tabPage1.ResumeLayout(false);
-            this.tabPage2.ResumeLayout(false);
-            this.tabControl2.ResumeLayout(false);
-            this.tabPage4.ResumeLayout(false);
-            this.tabControl3.ResumeLayout(false);
-            this.tabPage5.ResumeLayout(false);
-            this.tabPage5.PerformLayout();
-            this.tabPage6.ResumeLayout(false);
             ((System.ComponentModel.ISupportInitialize)(this.dgvUsers)).EndInit();
-            ((System.ComponentModel.ISupportInitialize)(this.dgvRoles)).EndInit();
-            this.panel1.ResumeLayout(false);
+            ((System.ComponentModel.ISupportInitialize)(this.bsUsers)).EndInit();
+            this.tcUser.ResumeLayout(false);
             this.tabPage3.ResumeLayout(false);
             this.tabPage3.PerformLayout();
-            ((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).EndInit();
-            ((System.ComponentModel.ISupportInitialize)(this.dataGridView2)).EndInit();
+            ((System.ComponentModel.ISupportInitialize)(this.bsUser)).EndInit();
+            this.tabPage2.ResumeLayout(false);
+            ((System.ComponentModel.ISupportInitialize)(this.dgvRoles)).EndInit();
+            ((System.ComponentModel.ISupportInitialize)(this.bsRoles)).EndInit();
+            this.tcRole.ResumeLayout(false);
+            this.tpRoleDetail.ResumeLayout(false);
+            this.tpRoleDetail.PerformLayout();
+            ((System.ComponentModel.ISupportInitialize)(this.bsRole)).EndInit();
+            this.tabPage6.ResumeLayout(false);
+            this.tabPage6.PerformLayout();
+            ((System.ComponentModel.ISupportInitialize)(this.dgvRoleAssignedUsers)).EndInit();
+            ((System.ComponentModel.ISupportInitialize)(this.bsRoleUsers)).EndInit();
+            ((System.ComponentModel.ISupportInitialize)(this.dgvRoleAvailableUsers)).EndInit();
+            ((System.ComponentModel.ISupportInitialize)(this.bsUserRoles)).EndInit();
             this.ResumeLayout(false);
 
@@ -565,35 +701,46 @@
         private System.Windows.Forms.TabPage tabPage1;
         private System.Windows.Forms.DataGridView dgvUsers;
-        private System.Windows.Forms.TabControl tabControl2;
-        private System.Windows.Forms.TabPage tabPage4;
+        private System.Windows.Forms.TabControl tcUser;
         private System.Windows.Forms.TabPage tabPage2;
         private System.Windows.Forms.DataGridView dgvRoles;
-        private System.Windows.Forms.TabControl tabControl3;
-        private System.Windows.Forms.TabPage tabPage5;
+        private System.Windows.Forms.TabControl tcRole;
+        private System.Windows.Forms.TabPage tpRoleDetail;
         private System.Windows.Forms.TabPage tabPage6;
         private System.Windows.Forms.Panel panel1;
         private System.Windows.Forms.Label label1;
-        private System.Windows.Forms.DataGridViewTextBoxColumn membershipDataGridViewTextBoxColumn;
-        private System.Windows.Forms.DataGridViewTextBoxColumn applicationIdDataGridViewTextBoxColumn;
-        private System.Windows.Forms.DataGridViewTextBoxColumn userIdDataGridViewTextBoxColumn;
-        private System.Windows.Forms.DataGridViewTextBoxColumn userNameDataGridViewTextBoxColumn;
-        private System.Windows.Forms.DataGridViewTextBoxColumn loweredUserNameDataGridViewTextBoxColumn;
-        private System.Windows.Forms.DataGridViewTextBoxColumn mobileAliasDataGridViewTextBoxColumn;
-        private System.Windows.Forms.DataGridViewCheckBoxColumn isAnonymousDataGridViewCheckBoxColumn;
-        private System.Windows.Forms.DataGridViewTextBoxColumn lastActivityDateDataGridViewTextBoxColumn;
+        private System.Windows.Forms.TextBox roleNameTextBox;
+        private System.Windows.Forms.Button btnNewUser;
+        private System.Windows.Forms.BindingSource bsUser;
+        private System.Windows.Forms.Button btnNewRole;
+        private System.Windows.Forms.BindingSource bsRole;
+        private System.Windows.Forms.BindingSource bsUserRoles;
+        private System.Windows.Forms.BindingSource bsRoleUsers;
+        private System.Windows.Forms.DataGridView dgvRoleAvailableUsers;
+        private System.Windows.Forms.Button btnAddUserToRole;
+        private System.Windows.Forms.Button btnRemoveUserFromRole;
+        private System.Windows.Forms.Button btnSaveRole;
+        private System.Windows.Forms.TextBox descriptionTextBox;
+        private System.Windows.Forms.Button btnDeleteRole;
+        private System.Windows.Forms.DataGridView dgvRoleAssignedUsers;
+        private System.Windows.Forms.ComboBox cbxApplication;
+        private System.Windows.Forms.BindingSource bsApplications;
+        private System.Windows.Forms.Button btnDeleteUser;
         private System.Windows.Forms.TabPage tabPage3;
+        private System.Windows.Forms.Button btnSaveUser;
+        private System.Windows.Forms.TextBox passwordQuestionTextBox;
+        private System.Windows.Forms.TextBox passwordTextBox;
+        private System.Windows.Forms.TextBox userNameTextBox;
         private System.Windows.Forms.TextBox emailTextBox;
         private System.Windows.Forms.TextBox passwordSaltTextBox;
-        private System.Windows.Forms.TextBox passwordQuestionTextBox;
-        private System.Windows.Forms.TextBox passwordAnswerTextBox;
-        private System.Windows.Forms.TextBox passwordTextBox;
-        private System.Windows.Forms.CheckBox isAnonymousCheckBox;
-        private System.Windows.Forms.DataGridView dataGridView1;
-        private System.Windows.Forms.DataGridViewTextBoxColumn roleIdDataGridViewTextBoxColumn;
+        private System.Windows.Forms.Label label3;
+        private System.Windows.Forms.Label label2;
+        private System.Windows.Forms.DataGridViewTextBoxColumn userNameDataGridViewTextBoxColumn2;
+        private System.Windows.Forms.DataGridViewTextBoxColumn userNameDataGridViewTextBoxColumn1;
         private System.Windows.Forms.DataGridViewTextBoxColumn roleNameDataGridViewTextBoxColumn;
         private System.Windows.Forms.DataGridViewTextBoxColumn loweredRoleNameDataGridViewTextBoxColumn;
         private System.Windows.Forms.DataGridViewTextBoxColumn descriptionDataGridViewTextBoxColumn;
-        private System.Windows.Forms.TextBox roleNameTextBox;
-        private System.Windows.Forms.DataGridView dataGridView2;
+        private System.Windows.Forms.DataGridViewTextBoxColumn userNameDataGridViewTextBoxColumn;
+        private System.Windows.Forms.DataGridViewCheckBoxColumn isAnonymousDataGridViewCheckBoxColumn;
+        private System.Windows.Forms.DataGridViewTextBoxColumn Membership;
     }
 }
